> module Angabe4 where

1. Vervollstaendigen Sie gemaess Angabentext!
2. Vervollst�ndigen Sie auch die vorgegebenen Kommentaranf�nge!
3. Loeschen Sie keine Deklarationen aus diesem Rahmenprogramm, auch nicht die Modulanweisug!
4. Achten Sie darauf, dass `Gruppe' Leserechte fuer Ihre Abgabedatei hat!


Datenstrukturen fuer eine einfache Buchhaltung:

> type Nat1    = Int
> type Name    = String
> newtype Cent = C { cents :: Nat1
>                  } deriving (Eq,Ord,Show)
> type Brutto  = Cent
> type Netto   = Cent
> data Skonto  = KeinSkonto | DreiProzent
>                | FuenfProzent | ZehnProzent deriving (Eq,Ord,Show)
> data Tag     = I | II | III | IV | V | VI | VII | VIII | IX | X
>                | XI | XII | XIII | XIV | XV | XVI | XVII | XVIII
>                | XIX | XX | XXI | XXII | XXIII | XXIV | XXV
>                | XXVI | XXVII | XXVIII | XXIX | XXX
>                | XXXI deriving (Eq,Ord,Show)
> data Monat   = Jan | Feb | Mar | Apr | Mai | Jun | Jul | Aug
>                | Sep | Okt | Nov | Dez deriving (Eq,Ord,Show)
> type Jahr    = Nat1
> data Datum   = D { tag   :: Tag,
>                    monat :: Monat,
>                    jahr  :: Jahr
>                  } deriving (Eq,Show)

> data Geschaeftspartner = GP { partner :: Name,
>                               seit :: Datum
>                              } deriving (Eq,Show)
> data Geschaeftsvorfall = Zahlung { brutto :: Brutto,
>                                    skonto :: Skonto,
>                                    zahlung_vom :: Datum
>                                  }
>                          | Gutschrift { gutschriftsbetrag :: Cent,
>                                         gutschrift_vom :: Datum
>                                       }
>                          deriving (Eq,Show)
> type Kassabucheintrag = (Geschaeftspartner,Geschaeftsvorfall)
> newtype Kassabuch = KB [Kassabucheintrag] deriving (Eq,Show)

Helper functions:

> day_to_str :: Tag -> String
> day_to_str I = "01"
> day_to_str II = "02"
> day_to_str III = "03"
> day_to_str IV = "04"
> day_to_str V = "05"
> day_to_str VI = "06"
> day_to_str VII = "07"
> day_to_str VIII = "08"
> day_to_str IX = "09"
> day_to_str X = "10"
> day_to_str XI = "11"
> day_to_str XII = "12"
> day_to_str XIII = "13"
> day_to_str XIV = "14"
> day_to_str XV = "15"
> day_to_str XVI = "16"
> day_to_str XVII = "17"
> day_to_str XVIII = "18"
> day_to_str XIX = "19"
> day_to_str XX = "20"
> day_to_str XXI = "21"
> day_to_str XXII = "22"
> day_to_str XXIII = "23"
> day_to_str XXIV = "24"
> day_to_str XXV = "25"
> day_to_str XXVI = "26"
> day_to_str XXVII = "27"
> day_to_str XXVIII = "28"
> day_to_str XXIX = "29"
> day_to_str XXX = "30"
> day_to_str XXXI = "31"

> month_to_str :: Monat -> String
> month_to_str Jan = "01"
> month_to_str Feb = "02"
> month_to_str Mar = "03"
> month_to_str Apr = "04"
> month_to_str Mai = "05"
> month_to_str Jun = "06"
> month_to_str Jul = "07"
> month_to_str Aug = "08"
> month_to_str Sep = "09"
> month_to_str Okt = "10"
> month_to_str Nov = "11"
> month_to_str Dez = "12"

> day_to_int :: Tag -> Int
> day_to_int I = 1
> day_to_int II = 2
> day_to_int III = 3
> day_to_int IV = 4
> day_to_int V = 5
> day_to_int VI = 6
> day_to_int VII = 7
> day_to_int VIII = 8
> day_to_int IX = 9
> day_to_int X = 10
> day_to_int XI = 11
> day_to_int XII = 12
> day_to_int XIII = 13
> day_to_int XIV = 14
> day_to_int XV = 15
> day_to_int XVI = 16
> day_to_int XVII = 17
> day_to_int XVIII = 18
> day_to_int XIX = 19
> day_to_int XX = 20
> day_to_int XXI = 21
> day_to_int XXII = 22
> day_to_int XXIII = 23
> day_to_int XXIV = 24
> day_to_int XXV = 25
> day_to_int XXVI = 26
> day_to_int XXVII = 27
> day_to_int XXVIII = 28
> day_to_int XXIX = 29
> day_to_int XXX = 30
> day_to_int XXXI = 31

> month_to_int :: Monat -> Int
> month_to_int Jan = 1
> month_to_int Feb = 2
> month_to_int Mar = 3
> month_to_int Apr = 4
> month_to_int Mai = 5
> month_to_int Jun = 6
> month_to_int Jul = 7
> month_to_int Aug = 8
> month_to_int Sep = 9
> month_to_int Okt = 10
> month_to_int Nov = 11
> month_to_int Dez = 12

> int_to_day :: Int -> Tag
> int_to_day 1 = I
> int_to_day 2 = II
> int_to_day 3 = III
> int_to_day 4 = IV
> int_to_day 5 = V
> int_to_day 6 = VI
> int_to_day 7 = VII
> int_to_day 8 = VIII
> int_to_day 9 = IX
> int_to_day 10 = X
> int_to_day 11 = XI
> int_to_day 12 = XII
> int_to_day 13 = XIII
> int_to_day 14 = XIV
> int_to_day 15 = XV
> int_to_day 16 = XVI
> int_to_day 17 = XVII
> int_to_day 18 = XVIII
> int_to_day 19 = XIX
> int_to_day 20 = XX
> int_to_day 21 = XXI
> int_to_day 22 = XXII
> int_to_day 23 = XXIII
> int_to_day 24 = XXIV
> int_to_day 25 = XXV
> int_to_day 26 = XXVI
> int_to_day 27 = XXVII
> int_to_day 28 = XXVIII
> int_to_day 29 = XXIX
> int_to_day 30 = XXX
> int_to_day 31 = XXXI

> int_to_month :: Int -> Monat
> int_to_month 1 = Jan
> int_to_month 2 = Feb
> int_to_month 3 = Mar
> int_to_month 4 = Apr
> int_to_month 5 = Mai
> int_to_month 6 = Jun
> int_to_month 7 = Jul
> int_to_month 8 = Aug
> int_to_month 9 = Sep
> int_to_month 10 = Okt
> int_to_month 11 = Nov
> int_to_month 12 = Dez

> skonto_to_num :: Skonto -> Float
> skonto_to_num s
>   | s == KeinSkonto = 0
>   | s == DreiProzent = 0.03
>   | s == FuenfProzent = 0.05
>   | otherwise = 0.1

> full_months::[Monat]
> full_months = [Jan, Mar, Mai, Jul, Aug, Okt, Dez]

> is_date_valid :: Datum -> Bool
> is_date_valid d
>   | monat d == Feb =
>      let y = jahr d in
>      let t = tag d in
>         if y `mod` 4 /= 0 && (day_to_int t) > 28 then False
>         else
>            if y `mod` 100 == 0 && y `mod` 400 /= 0 then False
>            else
>               if (day_to_int t) > 29 then False
>               else True
>   | (day_to_int (tag d)) > 30 && not(monat d `elem` full_months) = False
>   | otherwise = True

> is_payment :: Geschaeftsvorfall -> Bool
> is_payment g =
>   case g of
>      Zahlung _ _ _ -> True
>      _ -> False

> is_credit :: Geschaeftsvorfall -> Bool
> is_credit g =
>   case g of
>      Gutschrift _ _ -> True
>      _ -> False


Aufgabe A.1

> type P_Geschaeftspartner = Geschaeftspartner
> data AP_Geschaeftsvorfall
>    = AP_Zahlung { netto :: Netto,
>                   zahlungsdatum :: Datum
>                 }
>     | P_Gutschrift { gutschrift :: Cent,
>                      gutschriftsdatum :: Datum
>                    } deriving (Eq,Show)
> type AP_Kassabucheintrag = (P_Geschaeftspartner,AP_Geschaeftsvorfall)


> waup :: Kassabucheintrag -> AP_Kassabucheintrag
> waup (g, v) = eval_payment_sum $ eval_payment_date (g, v)


> eval_payment_date :: Kassabucheintrag -> Kassabucheintrag
> eval_payment_date (g, v)
>   | (is_payment v) && (is_date_valid (zahlung_vom v)) =
>       if is_date_valid (seit g) then (g, v)
>       else (g', v)
>   | (is_credit v) && (is_date_valid (gutschrift_vom v)) =
>       if is_date_valid (seit g) then (g, v)
>       else (g', v)
>   | otherwise =
>       if (is_payment v) then (g', z)
>       else (g', gs)
>   where
>       g' = GP (partner g) (correct_date (seit g))
>       z = Zahlung (brutto v) (skonto v) (correct_date (zahlung_vom v))
>       gs = Gutschrift (gutschriftsbetrag v) (correct_date (gutschrift_vom v))


> eval_payment_sum :: Kassabucheintrag -> AP_Kassabucheintrag
> eval_payment_sum (g, v) = (g, correct_sum v)

> correct_date :: Datum -> Datum
> correct_date d
>   | monat d == Feb =
>         if y `mod` 4 /= 0 && (day_to_int t) > 28 then fm
>         else
>            if y `mod` 100 == 0 && y `mod` 400 /= 0 then fm
>            else
>               if (day_to_int t) > 29 then fm
>               else d
>   | (day_to_int t) > 30 && not(monat d `elem` full_months) = nm
>   | otherwise = d
>   where
>       y = jahr d
>       t = tag d
>       fm = D (int_to_day 1) Mar y
>       nm = D (int_to_day 1) (int_to_month ((month_to_int (monat d)) + 1)) y

> correct_sum :: Geschaeftsvorfall -> AP_Geschaeftsvorfall
> correct_sum g
>   | is_credit g = P_Gutschrift (gutschriftsbetrag g) (gutschrift_vom g)
>   | otherwise = AP_Zahlung n (zahlung_vom g)
>   where
>       b = fromInteger (toInteger (cents (brutto g))) :: Float -- convert b to float
>       s = skonto_to_num (skonto g)
>       n = C ((round(b - (b * s))) :: Nat1)


Aufgabe A.2

% > data EuroCent = EC { euro :: Nat1,
% >                      cent :: Nat1

%                        Nur Werte zwischen 0 und 99 fuer cent!

% >                    } deriving (Eq,Ord,Show)

% > data K_Geschaeftsvorfall = K_Zahlung { ec_netto :: EuroCent,
% >                                        zahlungsdatum' :: Datum
% >                                      }
% >                            | K_Gutschrift { ec_gutschrift :: EuroCent,
% >                                             gutschriftsdatum' :: Datum
% >                                           } deriving (Eq,Show)

% > newtype KonsolidiertesKassabuch
% >     = KKB [(P_Geschaeftspartner,K_Geschaeftsvorfall)]
% >       deriving (Eq,Show)

% > konsolidiere :: Kassabuch -> KonsolidiertesKassabuch

Knapp, aber gut nachvollziehbar geht konsolidiere folgendermassen vor:
 ...


Aufgabe A.3

% > data Saldo = Forderungssaldo { fs :: EuroCent }
% >              | Zahlungssaldo { zs :: EuroCent }
% >              | Ausgeglichen
% >              | Keine_Geschaeftsbeziehung deriving (Eq,Show)

% > saldo :: P_Geschaeftspartner -> KonsolidiertesKassabuch -> Saldo

Knapp, aber gut nachvollziehbar geht saldo folgendermassen vor:
...


Aufgabe A.4

% > newtype SaldiertesKassabuch = SKB [(Geschaeftspartner,Saldo)]

% > saldiere :: Kassabuch -> SaldiertesKassabuch

Knapp, aber gut nachvollziehbar geht saldiere folgendermassen vor:
...
